import json, requests,time, sys
import csv
import urllib3
import datetime
urllib3.disable_warnings(urllib3.exceptions.InsecureRequestWarning)
from AOS8_API_CALLER_CLASS import *

global_debug_to_screen=True
# CHANGE THESE VALUES
IP="IP"
USERNAME="USERNAME"
PASSWORD="PASSWORD"


# ******************************** LOGGING IN *******************************
if __name__ == "__main__":
    try:
        if global_debug_to_screen:
            print("Trying to login...")
        session = api_session(IP, USERNAME, PASSWORD,4343,True,False,False,3,5)
        session.login()
        if global_debug_to_screen:
            print("After logging in. API Token is " + session.api_token)


# ************* Executing Command 1 - global-user-table list  ***************
        if global_debug_to_screen:
            print("{:-^141s}".format("Command 1: show global-user-table list"))

        command_output_json= session.cli_command("show global-user-table list")
        #print("JSON Output is:")
        #print(json.dumps(command_output_json))

        now = datetime.datetime.now()

        with open(now.strftime("%Y_%m_%d_%H_%M_")+'users.csv', 'w', newline='') as writefile:
            writer = csv.writer(writefile, delimiter=",")
            writer.writerow(["USER MAC", "USER IP", "AP name", "Essid", "Role"])
            if global_debug_to_screen:
                print("Subset of Output is:")
                print("{0:<30}\t{1:<30}\t{2:<30}\t{3:<30}\t{4:<30}".format("USER MAC", "USER IP", "AP name", "Essid", "Role"))
            for user in command_output_json["Global Users"]:
                if global_debug_to_screen:
                    print("{0:<30}\t{1:<30}\t{2:<30}\t{3:<30}\t{4:<30}".format(user["MAC"], user["IP"], user["AP name"], user["Essid"],user["Role"]))
                writer.writerow([user["MAC"],user["IP"],user["AP name"],user["Essid"],user["Role"]])

            writefile.close()

# ************* Executing Command 2 - show ap database long     ***************
        if global_debug_to_screen:
            print("{:-^141s}".format("Command 2: show ap database long "))
        command_output_json= session.cli_command("show ap database long")
       # print("JSON Output is:")
       # print(json.dumps(command_output_json))


        with open(now.strftime("%Y_%m_%d_%H_%M_")+'aps.csv', 'w', newline='') as writefile:
            writer = csv.writer(writefile, delimiter=",")
            writer.writerow(["AP", "GROUP","Status","Serial #"])
            if global_debug_to_screen:
                print("Subset of Output is:")
                print("{0:<30}\t{1:<30}\t{2:<30}\t{3:<30}".format("AP", "GROUP","Status","Serial #"))
            for ap in command_output_json["AP Database"]:
                if global_debug_to_screen:
                    print("{0:<30}\t{1:<30}\t{2:<30}\t{3:<30}".format(ap["Name"],ap["Group"],ap["Status"],ap["Serial #"]))
                writer.writerow([ap["Name"],ap["Group"],ap["Status"],ap["Serial #"]])

            writefile.close()

# ********************************** LOGGING OUT ***************************
        if global_debug_to_screen:
            print("Logging Out...")
        session.logout()
    except Exception as e:
        print("An error happened while running the main function. Error details are " + str(e))
    exit()